<template>
  <div class="page-wrapper">
    <checkout-header v-if="$route.path.includes('checkout') && !isMobile"
                     class="page-header" />
    <Header v-else
            class="page-header" />
    <main class="page-content">
      <nuxt />
    </main>
    <Footer class="page-footer" />
    <notifications group="errors"
                   position="top right"
                   :duration="2500"
                   classes="notification notification--error"
                   :max="3"
                   :width="'25rem'"/>
    <notifications group="success"
                   position="top right"
                   :duration="2500"
                   classes="notification notification--success"
                   :max="3"
                   :width="'25rem'"/>
  </div>
</template>

<script>
  import { mapMutations, mapActions } from 'vuex';

  import Header from '../components/Header.vue';
  import Footer from '../components/Footer.vue';
  import CheckoutHeader from '../components/CheckoutHeader';

  import { setContext } from '../service/deliroom-service';

  export default {
    name : 'Default',
    components: {
      CheckoutHeader,
      Header,
      Footer
    },

    data: () => ({
      windowWidth: 0,
    }),

    async beforeMount() {
      if (this.$cookiz.get('user-token')
        && this.$cookiz.get('user-token') !== 'undefined') {

        await this.refreshToken();

        if (!this.$cookiz.get('user-token')) return;

        this.startRefreshing();
      }
    },

    mounted() {
      this.onResize();
      window.addEventListener('resize', this.onResize);
      window.addEventListener('orientationchange', this.onResize);
    },

    beforeDestroy() {
      if (this.$cookiz.get('user-token')) {
        this.stopRefreshingToken();
      }
    },

    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      }
    },

    methods: {
      ...mapMutations([
        'changeScreenType',
      ]),

      ...mapMutations({
        setToken: 'auth/setToken',
        stopRefreshingToken: 'auth/stopRefreshingToken',
      }),

      ...mapActions({
        startRefreshing: 'auth/startRefreshing',
        refreshToken: 'auth/refreshToken',
        getUser: 'user/getUser',
        getAccountInfo: 'user/getAccountInfo'
      }),

      onResize() {
        setTimeout(() => {
          this.windowWidth = window.innerWidth;
          this.changeScreenType({ screenWidth: this.windowWidth });
        }, 10);
      }

    }

  }
</script>
